/**
 * {}
 * @author yutent<yutent.io@gmail.com>
 * @date 2023/08/10 11:57:38
 */

import { Component } from 'wkit'
import { __STORE__ } from './constants.js'

export function createStore(obj = {}) {
  let defined = false

  return function () {
    Object.defineProperty(Component.prototype, '$store', {
      get() {
        return window.wkitd.get(__STORE__)
      },
      set(val) {
        if (defined) {
          return console.error(
            'Can not set readonly property $store of Component'
          )
        }
        window.wkitd.set(
          __STORE__,
          new Proxy(val, {
            set(target, prop, value) {
              target[prop] = value
              window.wkitd.broadcast()
              return true
            }
          })
        )
        defined = true
      },
      enumerable: false
    })
    Component.prototype.$store = obj
  }
}
